<h3>{$lang['Edit IP Pool']}</h3>

<form method="post" action="{$before_path}/admin/addonmodules.php?module=puq_customization&extension=module_puq_proxmox_kvm&action=ip_pools">

    <table class="form" width="100%" border="0" cellspacing="2" cellpadding="3">
        <tbody>

        <tr>
            <td class="fieldlabel">{$lang['Server']}</td>
            <td class="fieldarea">
                <input type="hidden" name="id" value="{$ip_pool['id']}" />

                <select name="server_id" class="form-control select-inline" style="width: 100%;">
                    {foreach $servers as $value}
                        <option value="{$value['id']}" {if $ip_pool['server_id'] eq $value['id']} selected{/if}>{$value['id']} - {$value['name']}</option>
                    {/foreach}
                </select>
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Type']}</td>
            <td class="fieldarea">
                <select name="type" class="form-control select-inline">
                    <option value="ipv4"{if $ip_pool['type'] eq 'ipv4'} selected{/if}>IPv4</option>
                    <option value="ipv6"{if $ip_pool['type'] eq 'ipv6'} selected{/if}>IPv6</option>
                </select>
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Bridge']}</td>
            <td class="fieldarea">
                <input type="text" name="bridge" value="{$ip_pool['bridge']}" class="form-control input-inline input-100" required>
                {$lang['Interface Bridge on the server where addressing is available. Format: vmbrX']}
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Vlan']}</td>
            <td class="fieldarea">
                <input type="number" min="0" max="4095" step="1" name="vlan" value="{$ip_pool['vlan']}" class="form-control input-inline input-100" required>
                {$lang['Vlan on the server where addressing is available. 0 - untagged']}
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Gateway']}</td>
            <td class="fieldarea">
                <input type="text" name="gateway" value="{$ip_pool['gateway']}" class="form-control input-inline input-400" required>
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Mask']}</td>
            <td class="fieldarea">
                <input type="number" name="mask" min="1" max="128" step="1" value="{$ip_pool['mask']}" class="form-control input-inline input-100" required>
                {$lang['IPv4: 1-32, IPv6: 1-128']}
            </td>

        </tr>

        <tr>
            <td class="fieldlabel">{$lang['DNS1']}</td>
            <td class="fieldarea">
                <input type="text" name="dns1" value="{$ip_pool['dns1']}" class="form-control input-inline input-400">
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['DNS2']}</td>
            <td class="fieldarea">
                <input type="text" name="dns2" value="{$ip_pool['dns2']}" class="form-control input-inline input-400">
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Addresses']}</td>
            <td class="fieldarea">
                <input type="text" name="addresses" value="{$ip_pool['addresses']}" class="form-control input-inline input-600" required>
                <br>
                {$lang['IPv4: 10.0.0.1-10.0.255.255']}
                <br>
                {$lang['IPv6: 2001:0DB8:0000:0000:0000:0000:0000:0001-2001:0DB8:0000:0000:FFFF:FFFF:FFFF:FFFF']}
            </td>
        </tr>

        </tbody>
    </table>
    <div class="btn-container">
        <button type="submit" name="submit" value="edit_ip_pool" class="btn btn-primary">{$lang['Edit IP Pool']}</button>
        <button type="submit" name="submit" value="delete_ip_pool" class="btn btn-danger" onclick="return confirm('{$lang['Are you sure you want to delete?']}')" >{$lang['Delete IP Pool']}</button>
    </div>
</form>