<h3>{$lang['Add Countries Set']}</h3>

<button class="btn btn-default" id="selectEU">{$lang['Select EU countries']}</button>
<button class="btn btn-default" id="selectNonEU">{$lang['Select non-EU countries']}</button>

<button class="btn btn-default" id="selectCNG">{$lang['Select CNG countries']}</button>
<button class="btn btn-default" id="selectNonCNG">{$lang['Select non-CNG countries']}</button>

<br>
<form method="post" action="{$before_path}/admin/addonmodules.php?module=puq_customization&extension=overwrite_tax_rules&action=countries_set">
    <table class="form" width="100%" border="0" cellspacing="2" cellpadding="3">
        <tbody>

        <tr>
            <td class="fieldlabel">{$lang['Set name']}</td>
            <td class="fieldarea">
                <input type="text" name="name" value="" class="form-control input-inline input-300" required>
            </td>
        </tr>

        <tr>
            <td class="fieldlabel" style="min-width:200px;">{$lang['Countries']}</td>
            <td class="fieldarea">
                <ul style=" column-count: 4;">
                {foreach $countries as $key => $value}
                    <li>
                        <label class="checkbox-inline">
                            <input id="{$key}" type="checkbox" name="countries[{$key}]" value="1">[{$key}] - {$value['name']}
                        </label>
                    </li>
                {/foreach}
                </ul>
            </td>
        </tr>

        </tbody>
    </table>
    <div class="btn-container">
        <button type="submit" name="submit" value="add_countries_set" class="btn btn-primary">{$lang['Add Countries Set']}</button>
    </div>
</form>

<script>
    var euCountries = ["AT", "BE", "BG", "HR", "CY", "CZ", "DK", "EE", "FI", "FR", "DE", "GR", "HU", "IE", "IT", "LV", "LT", "LU", "MT", "NL", "PL", "PT", "RO", "SK", "SI", "ES", "SE"];
    var cngCountries = ["RU", "UA", "BY", "KZ", "UZ", "AM", "AZ", "TM", "KG", "TJ", "MD"];

    document.getElementById("selectEU").addEventListener("click", function() {
        setCountryCheckboxes(euCountries, false);
    });

    document.getElementById("selectNonEU").addEventListener("click", function() {
        setCountryCheckboxes(euCountries, true);
    });

    document.getElementById("selectCNG").addEventListener("click", function() {
        setCountryCheckboxes(cngCountries, false);
    });

    document.getElementById("selectNonCNG").addEventListener("click", function() {
        setCountryCheckboxes(cngCountries, true);
    });

    function setCountryCheckboxes(countries, invert) {
        var checkboxes = document.querySelectorAll("input[type='checkbox']");
        for (var i = 0; i < checkboxes.length; i++) {
            var country = checkboxes[i].getAttribute("id");

            if(invert) {
                if (countries.includes(country)) {
                    checkboxes[i].checked = false;
                } else {
                    checkboxes[i].checked = true;
                }
            }else{
                if (countries.includes(country)) {
                    checkboxes[i].checked = true;
                } else {
                    checkboxes[i].checked = false;
                }
            }
        }
    }
</script>